;+--------------------------------------------------------+
;|                                                     |\
;|                                            | |
;|   |                                   | |
;|    ||                                 | |
;|    ___ |                                    | |
;|     ___                                | |
;|                                                        | |
;+--------------------------------------------------------+ |
;|          For Doors CS v4.8.3 and higher                |\|
;|             --==By Kerm Martian==--                    | +
;|              Kerm_Martian@yahoo.com                    | |
;|              http://www.Cemetech.tk                    | |
;+--------------------------------------------------------+ |
;\_________________________________________________________\|


.nolist
#include "doorscs.inc"
.list
#ifdef TI83
pongVars .equ $8265
#endif
#ifdef TI83P
pongVars .equ $9872
#endif
BallType	.equ pongVars
LRay		.equ pongVars+1
RRay		.equ pongVars+4
LRayGun		.equ pongVars+7
RRayGun		.equ pongVars+8
LPAD		.equ pongVars+9
RPAD		.equ pongVars+10
LPADLENGTH	.equ pongVars+11
RPADLENGTH	.equ pongVars+12
POWERUP		.equ pongVars+13
SPEEDUP		.equ pongVars+14
XINC		.equ pongVars+15
YINC		.equ pongVars+16
XPOS		.equ pongVars+17
YPOS		.equ pongVars+18
XPOS1		.equ pongVars+19
YPOS1		.equ pongVars+20
Error		.equ pongVars+21
Round		.equ pongVars+22
LScore		.equ pongVars+23
RScore		.equ pongVars+24

	.org progstart
#IFDEF TI83P
	.db $BB,$6D
#ENDIF
	xor d
#IFDEF TI83P
	.db $C9
#ENDIF
	jr Start
	.dw $0000
	.db $05,$00
	.dw Icon
	.dw $0000
Start:
	xor a
	ld (PowerUp),a
	bcall(_grbufclr)
	set textwrite,(iy+sgrflags)
	bcall(_ClrLcdFull)
	call LargeWindow
	ld hl,Titletxt
	ld a,1
	ld (PENROW),a
	ld a,7
	ld (PENCOL),a
	bcall(_vputs)
	ld a,2
	ld (PENCOL),a
	ld a,11
	ld (PENROW),a
	ld hl,AuthorTxt
	bcall(_vputs)
	ld a,2
	ld (PENCOL),a
	ld a,20
	ld (PENROW),a
	ld hl,MainMenuTxt1
	bcall(_vputs)
	ld a,2
	ld (PENCOL),a
	ld a,27
	ld (PENROW),a
	ld hl,MainMenuTxt2
	bcall(_vputs)
	ld a,2
	ld (PENCOL),a
	ld a,34
	ld (PENROW),a
	ld hl,MainMenuTxt3
	bcall(_vputs)
	ld a,56
	ld (PENROW),a
	ld a,2
	ld (PENCOL),a
	ld hl,HighScoreTxt
	bcall(_vputs)
	ld a,(HighScore)
	bcall(_setxxop1)
	ld a,3
	bcall(_dispop1a)
	ld l,2
	ld a,2
	ld b,4
	ld ix,pongball
	call iPutSprite
	call iFastCopy
	call Pause
	ld hl,pongVars
	ld b,25
InitVarClear:
	ld (hl),0
	inc hl
	djnz InitVarClear
	xor a
	ld (LRayGun),a
	ld (RRayGun),a
	ld a,20
	ld (LPAD),a
	ld (RPAD),a
	ld (LPADLEngth),a
	ld (RPADLENGTH),a
	ld a,29
	ld (YPos),a
	ld (YPos1),a
NEXTROUND:
;
	ld a,(Error)
	dec a
	jr z,PlrError
	dec a
	jr nz,NoError
	ld a,(LScore)
	inc a
	ld (LScore),a
	jr NoError
PlrError:
	ld a,(RScore)
	inc a
	ld (RScore),a
NoError:
	xor a
	ld (Error),a
	ld (BallType),a
	ld (PowerUp),a
	ld (SpeedUp),a
	inc a
	ld (Xinc),a
	dec a
	dec a
	ld (Yinc),a
	ld a,45
	ld (Xpos),a
	ld (Xpos1),a
	ld b,50
	call iRandom
	ld (YPos),a
;
	bcall(_ClrLCDFull)
	ld a,(Round)
	inc a
	ld (Round),a
	cp 22
	jp z,GameOver
	push af
	ld a,38
	ld (PENCOL),a
	ld a,24
	ld (PENROW),a
	ld hl,bottomtxt
	bcall(_vputs)
	pop af
	call VDispA
	call iFastCopy
	call Pause
INITSCREEN:
	bcall(_ClrLCDFull)
	bcall(_grbufclr)
	ld hl,bottomtxt
	ld a,1
	ld (PENCOL),a
	ld a,57
	ld (PENROW),a
	bcall(_vputs)
	ld a,(Round)
	call VDispA
	ld hl,bottomtxt1
	bcall(_vputs)
	ld a,(LScore)
	call VDispA
	ld hl,bottomTxt2
	bcall(_vputs)
	ld h,0
	ld a,(RScore)
	call VDispA
DRAWLOOP:
	call LPADDRAW
	call RPADDRAW
MAINLOOP:
	call DrawRay
	ld hl,pongball
	ld d,0
	ld a,(ballType)
	sla a
	sla a
	sla a
	ld e,a
	add hl,de
	push hl
	pop ix
	ld a,(YPOS)
	ld (YPOS1),a
	ld l,a
	ld a,(XPOS)
	ld (XPOS1),a
	ld b,8
	call iPutSprite
	call iFastCopy
	ld a,(XINC)
	ld b,a
	ld a,(XPOS)
	add a,b
	ld (XPOS),a
	ld a,(YINC)
	ld b,a
	ld a,(YPOS)
	add a,b
	ld (YPOS),a
	cp 52
	call nc,YSWITCH
	ld (YPOS),a
	cp 2
	call c,YSWITCH
	ld a,(XPOS)
	cp 40
	jr c,Main_NoPU
	cp 48
	jr nc,Main_NoPU
	ld a,(YPos)
	cp 27
	jr c,Main_NoPU
	cp 35
	jr nc,Main_NoPU
	ld a,(PowerUp)
	or a
	call nz,GetPowerUp
Main_NoPU:
	ld a,(XPos)
	cp 2
	call z,XSWITCH
	ld a,(XPOS)
	cp 90
	call z,XSWITCH
	ld a,(Error)
	or a
	jp nz,NEXTROUND
	ld a,(SPEEDUP)
	cp 1
	jr z,DelayLoopEnd
	cp 2
	jr nz,DelayLoop
	ld hl,0fffh
	jr DelayLoop1
DELAYLOOP:
	ld hl,08ffh
DELAYLOOP1:
	dec hl
	ld a,h
	or l
	jr nz,DELAYLOOP1
DELAYLOOPEND:
AIROUTINES:
	ld a,(RPAD)
	ld b,a
	push bc
	inc b
	inc b
	inc b
	ld a,(YPOS)
	cp b
	pop bc
	jp m,AIMOVEUP
	push af
	ld a,(RPADLENGTH)
	add a,b
	ld b,a
	pop af
	dec b
	dec b
	dec b
	cp b
	jp p,AIMOVEDOWN
KEYCHECK:
	ld a,0ffh
	out (1),a
	ld a,0feh
	out (1),a
	nop
	in a,(1)
	cp 254
	jp z,MOVEDOWN
	cp 247
	jp z,MOVEUP
	ld a,0bfh
	out (1),a
	ld a,(LRAYGUN)
	ld b,a
	nop
	in a,(1)
	cp 127
	jp z,QUIT
	sub b
	sub 222
	call z,SetRayLeft
KEYCHECKRET:
	call ERASEBALL
	call DrawRay
	ld a,(LRay)
	or a
	jr z,NoLRayInc
	inc a
	inc a
	ld (LRay),a
	cp 90
	call z,EndLRay
NOLRayInc:
	ld a,(RRay)
	or a
	jr z,CheckSetRight
	dec a
	dec a
	ld (RRay),a
	cp 2
	call z,EndRRay
NoRRayInc:
	jp MAINLOOP
CheckSetRight:
	ld b,64
	call iRandom
	or a
	jr nz,NoRRayInc
	ld a,(RRayGun)
	or a
	jr z,NoRRayInc
	ld a,86
	ld (RRay),a
	ld a,(RPAD)
	ld (RRay+1),a
	ld b,a
	ld a,(RPadLength)
	add a,b
	ld (RRay+2),a
	jr NoRRayInc
EndLRay:
	xor a
	ld (LRay),a
	ld b,2
	ld hl,LRay+1
EndLRayLoop:
	ld c,(hl)
	inc c
	ld a,(RPad)
	cp c
	jr nc,EndLRayLoop1
	ld d,a
	ld a,(RPadLength)
	add a,d
	cp c
	jr nc,RHit
EndLRayLoop1:
	inc hl
	djnz EndLRayLoop
	ret
EndRRay:
	xor a
	ld (RRay),a
	ld b,2
	ld hl,RRay+1
EndRRayLoop:
	ld c,(hl)
	inc c
	ld a,(LPad)
	cp c
	jr nc,EndRRayLoop1
	ld d,a
	ld a,(LPadLength)
	add a,d
	cp c
	jr nc,LHit
EndRRayLoop1:
	inc hl
	djnz EndRRayLoop
	ret
RHit:
	pop hl
	ld a,2
	ld (error),a
NextRoundGo:
	jp NextRound
LHit:
	pop hl
	ld a,1
	ld (error),a
	jr NextRoundGo		;save 1 byte
ERASEBALL:
	ld hl,pongball
	ld d,0
	ld a,(ballType)
	sla a
	sla a
	sla a
	ld e,a
	add hl,de
	push hl
	pop ix
	ld a,(YPOS1)
	ld l,a
	ld a,(XPOS1)
	ld b,8
	jp iPutSprite
MOVEUP:
	ld a,(LPAD)
	or a
	jp z,KEYCHECKRET
	push af
	call ERASEBALL
	call LPADDRAW
	pop af
	dec a
	ld (LPAD),a
	call LPADDRAW
	call ERASEBALL
	jp KEYCHECKRET
MOVEDOWN:
	ld a,(LPADLENGTH)
	ld b,a
	ld a,(LPAD)
	add a,b
	cp 56
	jp z,KEYCHECKRET
	call ERASEBALL
	call LPADDRAW
	ld a,(LPAD)
	inc a
	ld (LPAD),a
	call LPADDRAW
	call ERASEBALL
	jp KEYCHECKRET
AIMOVEUP:
	ld a,(RPAD)
	or a
	jp z,KEYCHECK
	call RPADDRAW
	ld a,(RPAD)
	dec a
	ld (RPAD),a
	call RPADDRAW
	jp KEYCHECK
AIMOVEDOWN:
	ld b,a
	cp 56
	jp z,KEYCHECK
	call RPADDRAW
	ld a,(RPAD)
	inc a
	ld (RPAD),a
	call RPADDRAW
	jp KEYCHECK
XSWITCH:
	ld a,(POWERUP)
	or a
	jr nz,NOPOWERUP
	ld b,0ffh
	call iRandom
	cp 200d
	call p,POWERUPGO
NOPOWERUP:
	ld b,0
	ld a,(XPOS)
	sub 2
	call z,CHECKLEFT
	ld a,(XPOS)
	sub 90
	call z,CHECKRIGHT
	ld a,(XINC)
	ld b,a
	xor a
	sub b
	ld (XINC),a
	ld b,a
	ld a,(XPOS)
	add a,b
	ld (XPOS),a
	ret
CHECKLEFT:
	ld a,(LPAD)
	ld b,a
	ld a,(YPOS)
	cp b
	jp m,NOGOOD
	push bc
	push af
	ld a,4
	add a,b
	ld b,a
	pop af
	cp b
	call m,DECYPOS
	ld a,(LPAD)
	ld b,a
	ld a,(LPADLENGTH)
	add a,b
	ld b,a
	ld a,(YPOS)
	cp b
	jp p,NOGOOD1
	sub 4
	cp b
	pop bc
	call m,INCYPOS
	ret
CHECKRIGHT:
	ld a,(RPAD)
	ld b,a
	ld a,(YPOS)
	cp b
	jp m,NOGOOD2
	push bc
	push af
	ld a,4
	add a,b
	ld b,a
	pop af
	cp b
	call m,DecYPos
	ld a,(RPAD)
	ld b,a
	ld a,(RPADLENGTH)
	add a,b
	ld b,a
	ld a,(YPos)
	cp b
	jp p,NOGOOD21
	sub 4
	cp b
	pop bc
	call m,IncYPos
	ret
INCYPOS:
	ld hl,YINC
	inc (hl)
	ret
DECYPOS:
	ld hl,YINC
	dec (hl)
	ret
NOGood1:
	pop bc
NOGOOD:
	ld a,1
	ld (Error),a
	ret
NOGood21:
	pop bc
NOGOOD2:
	ld a,2
	ld (Error),a
	ret
YSWITCH:
	ld a,(YINC)
	ld b,a
	xor a
	sub b
	ld (YINC),a
	ld b,a
	ld a,(YPOS)
	add a,b
	ld (YPOS),a
	ret
QUIT:
	res textwrite,(iy+sgrflags)
	bcall(_ClrLCDFull)
	bcall(_homeup)
	ld hl,titletxt
	bcall(_puts)
	bcall(_newline)
	ld hl,authortxt
	bcall(_puts)
	bcall(_newline)
	bcall(_getk)
	ret                             ; Voila ! all done
POWERUPGO:
	ld b,6
	call iRandom
	inc a
	ld (PowerUp),a
	dec a
DrawPU:
	ld h,0
	sla a
	sla a
	sla a
	ld l,a
	ld de,POWERUPISTART
	add hl,de
	push hl
	pop ix
	ld l,27
	ld a,40
	ld b,8
	jp iPutSprite
LPADDRAW:
	ld a,(LPAD)
	ld b,a
	ld hl,PlotsScreen
	ld de,12d
	or a
	jr z,LPADNOLOOP
LPADLOOP:
	add hl,de
	djnz LPADLOOP
LPADNOLOOP:
	push hl
	ld a,(LRayGun)
	or a
	jr z,LPADNORG
	ld a,(hl)
	xor $0f
	ld (hl),a
	add hl,de
	ld a,(hl)
	xor $0c
	ld (hl),a
LPADNORG:
	pop hl
	ld a,(LPADLENGTH)
	ld b,a
LPADLOOP2:
	ld a,(hl)
	xor 0010000b
	ld (hl),a
	add hl,de
	djnz LPADLOOP2
	ld de,-12
	add hl,de
	ld a,(LRayGun)
	or a
	ret z
	ld a,(hl)
	xor $0f
	ld (hl),a
	add hl,de
	ld a,(hl)
	xor $0c
	ld (hl),a
	ret
RPADDRAW:
	ld a,(RPAD)
	ld b,a
	ld hl,PlotsScreen+11d
	ld de,12d
	or a
	jr z,RPADNOLOOP
RPADLOOP:
	add hl,de
	djnz RPADLOOP
RPADNOLOOP:
	push hl
	ld a,(RRayGun)
	or a
	jr z,RPADNORG
	ld a,(hl)
	xor $78
	ld (hl),a
	add hl,de
	ld a,(hl)
	xor $18
	ld (hl),a
RPADNORG:
	pop hl
	ld a,(RPADLENGTH)
	ld b,a
RPADLOOP2:
	ld a,(hl)
	xor 00000100b
	ld (hl),a
	add hl,de
	djnz RPADLOOP2
	ld de,-12
	add hl,de
	ld a,(RRayGun)
	or a
	ret z
	ld a,(hl)
	xor $78
	ld (hl),a
	add hl,de
	ld a,(hl)
	xor $18
	ld (hl),a
	ret
GetPowerUp:
	ld a,(PowerUp)
	dec a
	push af
	call DrawPU
	xor a
	ld (PowerUp),a
	pop af
	or a
	jr z,GPU_BallType
	dec a
	jr z,GPU_RayGun
	dec a
	jr z,GPU_SPad
	dec a
	jr z,GPU_BPad
	dec a
	jr z,GPU_Slow
	ld (SpeedUp),a
	ret
GPU_Slow:
	ld a,2
	ld (SpeedUp),a
	ret
GPU_BPad:
	call LPADDRAW
	call RPADDRAW
	ld de,0
	ld a,(XInc)
	inc a
	jr nz,GPU_BPad1
	ld e,1
GPU_BPad1:
	ld hl,LPADLENGTH
	add hl,de
	ld a,(hl)
	cp 52
	jr z,NoBPadNow
	add a,4
	ld (hl),a
NoBPadNow:
	call LPADDRAW
	call RPADDRAW
	ret
GPU_SPad:
	call LPADDRAW
	call RPADDRAW
	ld de,0
	ld a,(XInc)
	inc a
	jr nz,GPU_SPad1
	ld e,1
GPU_SPad1:
	ld hl,LPADLENGTH
	add hl,de
	ld a,(hl)
	cp 4
	jr z,NoSPadNow
	sub 4
	ld (hl),a
NoSPadNow:
	call LPADDRAW
	call RPADDRAW
	ret
GPU_RayGun:
	call LPADDRAW
	call RPADDRAW
	ld de,0
	ld a,(XInc)
	inc a
	jr nz,GPU_RayGun1
	ld e,1
GPU_RayGun1:
	ld hl,LRayGun
	add hl,de
	ld a,1
	ld b,(hl)
	sub b
	ld (hl),a
	call LPADDRAW
	call RPADDRAW
	ret
GPU_ballType:
	call ERASEBALL
	ld a,(BallType)
	ld b,a
	ld a,1
	sub b
	ld (BallType),a
	call ERASEBALL
	ret
GameOver:
	ld a,(LScore)
	ld b,a
	ld a,(RScore)
	sub b
	or a
	jp p,RWins
	ld hl,LWinTxt
	jr GameOver1
RWins:
	ld hl,RWinTxt
GameOver1:
	ld a,3
	ld (PENCOL),a
	ld (PENROW),a
	bcall(_vputs)
	ld a,50
	ld (PENROW),a
	ld a,1
	ld (PENCOL),a
	ld hl,ScoreTxt
	bcall(_vputs)
	ld a,(RScore)
	ld b,a
	ld a,(LScore)
	sub b
	or a
	jr nc,GameOver2
	xor a
GameOver2:
	add a,a
	add a,a
	add a,a
	ld b,a
	ld a,(HighScore)
	cp b
	jr nc,GameOver3
	ld a,b
	ld (HighScore),a
GameOver3:
	call VDispA
	call iFastCopy
	call Pause
	jp QUIT
SetRayLeft:
	ld a,(LRayGun)
	or a
	ret z
	ld a,(LRay)
	or a
	ret nz
	ld a,8
	ld (LRay),a
	ld a,(LPAD)
	ld (LRay+1),a
	ld b,a
	ld a,(LPadLength)
	add a,b
	ld (LRay+2),a
	jr NoRRay
DrawRay:
	ld a,(RRay)
	or a
	jr z,NoRRay
	ld ix,ShotLeft
	ld a,(RRay+1)
	ld l,a
	ld a,(RRay)
	ld b,3
	call iPutSprite
	ld ix,ShotLeft
	ld a,(RRay+2)
	ld l,a
	ld a,(RRay)
	ld b,3
	call iPutSprite
NoRRay:
	ld a,(LRay)
	or a
	ret z
	ld ix,ShotRight
	ld a,(LRay+1)
	ld l,a
	ld a,(LRay)
	ld b,3
	call iPutSprite
	ld ix,ShotRight
	ld a,(LRay+2)
	ld l,a
	ld a,(LRay)
	ld b,3
	jp iPutSprite
VDispA:
	bcall(_setxxop1)
	ld a,2
	bcall(_dispop1a)
	ret
LWinTxt:
	.db "You win!",0
RWinTxt:
	.db "Calculator wins!",0
authortxt:
	.db "By Kerm Martian",0
titletxt:
	.db "Pong v1.0",0
bottomtxt:
	.db "Round ",0
bottomtxt1:
	.db "| ",0
bottomtxt2:
	.db "to ",0
HighScore:
	.db $00
HighScoreTxt:
	.db "High Score: ",0
MainMenuTxt1:
	.db 0c1h,"Enter] = Play",0
MainMenuTxt2:
	.db 0c1h,"2nd] = Fire",0
MainMenuTxt3:
	.db 0c1h,"DEL] = Quit",0
ScoreTxt:
	.db "Score: ",0
ShotRight:
	.db %00000010
	.db %00011111
	.db %00000010
ShotLeft:
	.db %01000000
	.db %11111000
	.db %01000000
pongball:
	.db 01100000b
	.db 10110000b
	.db 11110000b
	.db 01100000b
	.db 0,0,0,0
POWERUPISTART:
pubigball:
pongballbig:
	.db 00111100b
	.db 01010010b
	.db 10100001b
	.db 11000011b
	.db 10000011b
	.db 10000111b
	.db 01011110b
	.db 00111100b
puraygun:
	.db 00011101b
	.db 01110111b
	.db 10000000b
	.db 10101010b
	.db 10101010b
	.db 10000000b
	.db 01110111b
	.db 00011101b
pusmall:
	.db 00000000b
	.db 00001100b
	.db 01010010b
	.db 11001000b
	.db 11000100b
	.db 11010010b
	.db 10001100b
	.db 00000000b
pubig:
	.db 01011110b
	.db 11011011b
	.db 11011011b
	.db 11011110b
	.db 11011011b
	.db 11011011b
	.db 11011110b
	.db 10000000b
puslow:
	.db 00000000b
	.db 00000110b
	.db 00001011b
	.db 00001111b
	.db 00100110b
	.db 00100000b
	.db 00011000b
	.db 00000000b
pufast:
	.db 00000000b
	.db 00000110b
	.db 00001011b
	.db 00001111b
	.db 00100110b
	.db 01100000b
	.db 01011000b
	.db 00110000b
Icon:
	.db %00000000,%00000000
	.db %00000000,%00000000
	.db %10000000,%00000000
	.db %10000000,%00000000
	.db %10000011,%00000000
	.db %10000101,%10000000
	.db %10000111,%10100001
	.db %10000011,%00100001
	.db %00000000,%00000001
	.db %00000001,%10000001
	.db %00000000,%00000001
	.db %00000000,%00000001
	.db %00000000,%00000000
	.db %11101110,%11001100
	.db %11101010,%10101010
	.db %10001110,%10101110
PongProgEnd:
.end
END